#include <math.h>
#include <stdio.h>
#include <intrin.h>
#include <windows.h>

#include <iostream>
#include <conio.h>
#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>
# include <math.h>

struct element  
{
	INT32 next;
	byte arr[60];

	operator INT32() { return next; }

	element& operator=(int n)
	{
		next = n;
		return *this;
	}
};

const int BLOCKSIZE_IN_BYTES = 3145728;//32768; //262144;  //3145728
const int MAX_WAY_NUMBER = 25;
const int OFFSET_IN_BYTES =  16777216; // 16 


template<typename type>
void FillArray(type* buffer, int fragmentSize, int offset, int numberOfWays)
{
	for(int i = 0; i < numberOfWays; i++)
	{
		for(int j = 0; j < fragmentSize; j++)
		{
			if(i < numberOfWays - 1)
				buffer[i * offset + j] = offset * (i + 1) + j;
			else
			{
				if(j < fragmentSize - 1)	
					buffer[i * offset + j] = j + 1;						
				else					
					buffer[i * offset + j] = 0;
			}		 
		}
	}
}


template<typename type>
unsigned long long* getResult(type buf[], int offsetInBytes, int maxWayNumber, int blockSizeInBytes)
{
	unsigned long long* results = new unsigned long long[MAX_WAY_NUMBER];
	if( buf == NULL)
	{
		exit(EXIT_FAILURE);
	}

	unsigned long long beginTime, endTime;

	int offset = offsetInBytes / sizeof(type);

	for(int i = 1; i < maxWayNumber; i++) 		
	{

		int fragmentSize = blockSizeInBytes / (sizeof(type) * i);	  
		int iterationsCount = fragmentSize * i;

		FillArray(buf, fragmentSize, offset, i); 

		type index;
		index = 0;

		beginTime = __rdtsc();
		for(int j = 0; j < iterationsCount; j++)
		{
			index = buf[index];
		}

		results[i] = __rdtsc() - beginTime; //

		//     
		if(index == 100)		
			printf("");
	}

	return results;
}




int main()
{
	SetPriorityClass(GetCurrentProcess(), REALTIME_PRIORITY_CLASS);

	int* buffer = (int *)_aligned_malloc((SIZE_T)(OFFSET_IN_BYTES * MAX_WAY_NUMBER), 64);

	//unsigned long long *results = getResult(buffer, OFFSET_IN_BYTES, MAX_WAY_NUMBER, BLOCKSIZE_IN_BYTES);

	int number = 5;
	unsigned long long *results = (unsigned long long *)_aligned_malloc((SIZE_T)(MAX_WAY_NUMBER * sizeof(unsigned long long )), 64);
	for(int j = 1; j < MAX_WAY_NUMBER; j++)	
		results[j] = 0;

	for(int i = 0; i < number - 1; i++)
	{
		unsigned long long *result = getResult(buffer, OFFSET_IN_BYTES, MAX_WAY_NUMBER, BLOCKSIZE_IN_BYTES);
		for(int j = 1; j < MAX_WAY_NUMBER; j++)		
			results[j] += result[j];
	}
	for(int j = 1; j < MAX_WAY_NUMBER; j++)		
		results[j] /= (number - 1);

	for(int i = 1; i < MAX_WAY_NUMBER; i++)	
		printf("%d %llu cycles\r\n", i , results[i]);
	
	_aligned_free(buffer);
	//delete(results);
	_getch();

	return 0;
}
